## mandos 1.0.8

=== Makefile ===
WARN=-O -Wall -Wformat=2 -Winit-self -Wmissing-include-dirs \
	-Wswitch-default -Wswitch-enum -Wunused-parameter \
	-Wstrict-aliasing=1 -Wextra -Wfloat-equal -Wundef -Wshadow \
	-Wunsafe-loop-optimizations -Wpointer-arith \
	-Wbad-function-cast -Wcast-qual -Wcast-align -Wwrite-strings \
	-Wconversion -Wstrict-prototypes -Wold-style-definition \
	-Wpacked -Wnested-externs -Winline -Wvolatile-register-var
#	-Wunreachable-code 
#DEBUG=-ggdb3
# For info about _FORTIFY_SOURCE, see
# <http://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>
FORTIFY=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIC -fPIE
LINK_FORTIFY_LD=-z relro -fPIE
LINK_FORTIFY=-pie
#COVERAGE=--coverage
OPTIMIZE=-Os
LANGUAGE=-std=gnu99
htmldir=man
version=1.0.8
SED=sed

## Use these settings for a traditional /usr/local install
# PREFIX=$(DESTDIR)/usr/local
# CONFDIR=$(DESTDIR)/etc/mandos
# KEYDIR=$(DESTDIR)/etc/mandos/keys
# MANDIR=$(PREFIX)/man
# INITRAMFSTOOLS=$(DESTDIR)/etc/initramfs-tools
##

## These settings are for a package-type install
PREFIX=$(DESTDIR)/usr
CONFDIR=$(DESTDIR)/etc/mandos
KEYDIR=$(DESTDIR)/etc/keys/mandos
MANDIR=$(PREFIX)/share/man
INITRAMFSTOOLS=$(DESTDIR)/usr/share/initramfs-tools
##

GNUTLS_CFLAGS=$(shell libgnutls-config --cflags)
GNUTLS_LIBS=$(shell libgnutls-config --libs)
AVAHI_CFLAGS=$(shell pkg-config --cflags-only-I avahi-core)
AVAHI_LIBS=$(shell pkg-config --libs avahi-core)
GPGME_CFLAGS=$(shell gpgme-config --cflags; getconf LFS_CFLAGS)
GPGME_LIBS=$(shell gpgme-config --libs; getconf LFS_LIBS; \
	getconf LFS_LDFLAGS)

# Do not change these two
CFLAGS=$(WARN) $(DEBUG) $(FORTIFY) $(COVERAGE) $(OPTIMIZE) \
	$(LANGUAGE) $(GNUTLS_CFLAGS) $(AVAHI_CFLAGS) $(GPGME_CFLAGS) \
	-DVERSION='"$(version)"'
LDFLAGS=$(COVERAGE) $(LINK_FORTIFY) $(foreach flag,$(LINK_FORTIFY_LD),-Xlinker $(flag))

# Commands to format a DocBook <refentry> document into a manual page
DOCBOOKTOMAN=cd $(dir $<); xsltproc --nonet --xinclude \
	--param man.charmap.use.subset		0 \
	--param make.year.ranges		1 \
	--param make.single.year.ranges		1 \
	--param man.output.quietly		1 \
	--param man.authors.section.enabled	0 \
	 /usr/share/xml/docbook/stylesheet/nwalsh/manpages/docbook.xsl \
	$(notdir $<); \
	$(MANPOST) $(notdir $@)
# DocBook-to-man post-processing to fix a '\n' escape bug
MANPOST=$(SED) --in-place --expression='s,\\\\en,\\en,g;s,\\n,\\en,g'

DOCBOOKTOHTML=xsltproc --nonet --xinclude \
	--param make.year.ranges		1 \
	--param make.single.year.ranges		1 \
	--param man.output.quietly		1 \
	--param man.authors.section.enabled	0 \
	--param citerefentry.link		1 \
	--output $@ \
	/usr/share/xml/docbook/stylesheet/nwalsh/xhtml/docbook.xsl \
	$<; $(HTMLPOST) $@
# Fix citerefentry links
HTMLPOST=$(SED) --in-place \
	--expression='s/\(<a class="citerefentry" href="\)\("><span class="citerefentry"><span class="refentrytitle">\)\([^<]*\)\(<\/span>(\)\([^)]*\)\()<\/span><\/a>\)/\1\3.\5\2\3\4\5\6/g'

PLUGINS=plugins.d/password-prompt plugins.d/mandos-client \
	plugins.d/usplash plugins.d/splashy plugins.d/askpass-fifo
CPROGS=plugin-runner $(PLUGINS)
PROGS=mandos mandos-keygen mandos-ctl $(CPROGS)
DOCS=mandos.8 plugin-runner.8mandos mandos-keygen.8 \
	plugins.d/mandos-client.8mandos \
	plugins.d/password-prompt.8mandos mandos.conf.5 \
	plugins.d/usplash.8mandos plugins.d/splashy.8mandos \
	plugins.d/askpass-fifo.8mandos mandos-clients.conf.5

htmldocs=$(addsuffix .xhtml,$(DOCS))

objects=$(addsuffix .o,$(CPROGS))

all: $(PROGS) mandos.lsm

doc: $(DOCS)

html: $(htmldocs)

%.5: %.xml common.ent legalnotice.xml
	$(DOCBOOKTOMAN)
%.5.xhtml: %.xml common.ent legalnotice.xml
	$(DOCBOOKTOHTML)

%.8: %.xml common.ent legalnotice.xml
	$(DOCBOOKTOMAN)
%.8.xhtml: %.xml common.ent legalnotice.xml
	$(DOCBOOKTOHTML)

%.8mandos: %.xml common.ent legalnotice.xml
	$(DOCBOOKTOMAN)
%.8mandos.xhtml: %.xml common.ent legalnotice.xml
	$(DOCBOOKTOHTML)

mandos.8: mandos.xml common.ent mandos-options.xml overview.xml \
		legalnotice.xml
	$(DOCBOOKTOMAN)
mandos.8.xhtml: mandos.xml common.ent mandos-options.xml \
		overview.xml legalnotice.xml
	$(DOCBOOKTOHTML)

mandos-keygen.8: mandos-keygen.xml common.ent overview.xml \
		legalnotice.xml
	$(DOCBOOKTOMAN)
mandos-keygen.8.xhtml: mandos-keygen.xml common.ent overview.xml \
		 legalnotice.xml
	$(DOCBOOKTOHTML)

mandos.conf.5: mandos.conf.xml common.ent mandos-options.xml \
		legalnotice.xml
	$(DOCBOOKTOMAN)
mandos.conf.5.xhtml: mandos.conf.xml common.ent mandos-options.xml \
		legalnotice.xml
	$(DOCBOOKTOHTML)

plugin-runner.8mandos: plugin-runner.xml common.ent overview.xml \
		legalnotice.xml
	$(DOCBOOKTOMAN)
plugin-runner.8mandos.xhtml: plugin-runner.xml common.ent \
		overview.xml legalnotice.xml
	$(DOCBOOKTOHTML)

plugins.d/mandos-client.8mandos: plugins.d/mandos-client.xml \
					common.ent \
					mandos-options.xml \
					overview.xml legalnotice.xml
	$(DOCBOOKTOMAN)
plugins.d/mandos-client.8mandos.xhtml: plugins.d/mandos-client.xml \
					common.ent \
					mandos-options.xml \
					overview.xml legalnotice.xml
	$(DOCBOOKTOHTML)

# Update all these files with version number $(version)
common.ent: Makefile
	$(SED) --in-place \
		--expression='s/^\(<!ENTITY version "\)[^"]*">$$/\1$(version)">/' \
		$@

mandos: Makefile
	$(SED) --in-place \
		--expression='s/^\(version = "\)[^"]*"$$/\1$(version)"/' \
		$@

mandos-keygen: Makefile
	$(SED) --in-place \
		--expression='s/^\(VERSION="\)[^"]*"$$/\1$(version)"/' \
		$@

mandos-ctl: Makefile
	$(SED) --in-place \
		--expression='s/^\(version = "\)[^"]*"$$/\1$(version)"/' \
		$@

mandos.lsm: Makefile
	$(SED) --in-place \
		--expression='s/^\(Version:\).*/\1\t$(version)/' \
		$@
	$(SED) --in-place \
		--expression='s/^\(Entered-date:\).*/\1\t$(shell date --rfc-3339=date --reference=Makefile)/' \
		$@
	$(SED) --in-place \
		--expression='s/\(mandos_\)[0-9.]\+\(\.orig\.tar\.gz\)/\1$(version)\2/' \
		$@

plugins.d/mandos-client: plugins.d/mandos-client.o
	$(LINK.o) $(GNUTLS_LIBS) $(AVAHI_LIBS) $(GPGME_LIBS) \
		$(COMMON) $^ $(LOADLIBES) $(LDLIBS) -o $@

.PHONY : all doc html clean distclean run-client run-server install \
	install-server install-client uninstall uninstall-server \
	uninstall-client purge purge-server purge-client

clean:
	-rm --force $(CPROGS) $(objects) $(htmldocs) $(DOCS) core

distclean: clean
mostlyclean: clean
maintainer-clean: clean
	-rm --force --recursive keydir confdir

check:	all
	./mandos --check

# Run the client with a local config and key
run-client: all keydir/seckey.txt keydir/pubkey.txt
	./plugin-runner --plugin-dir=plugins.d \
		--config-file=plugin-runner.conf \
		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt \
		$(CLIENTARGS)

# Used by run-client
keydir/seckey.txt keydir/pubkey.txt: mandos-keygen
	install --directory keydir
	./mandos-keygen --dir keydir --force

# Run the server with a local config
run-server: confdir/mandos.conf confdir/clients.conf
	./mandos --debug --no-dbus --configdir=confdir $(SERVERARGS)

# Used by run-server
confdir/mandos.conf: mandos.conf
	install --directory confdir
	install --mode=u=rw,go=r $^ $@
confdir/clients.conf: clients.conf keydir/seckey.txt
	install --directory confdir
	install --mode=u=rw $< $@
# Add a client password
	./mandos-keygen --dir keydir --password >> $@

install: install-server install-client-nokey

install-html: html
	install --directory $(htmldir)
	install --mode=u=rw,go=r --target-directory=$(htmldir) \
		$(htmldocs)

install-server: doc
	install --directory $(CONFDIR)
	install --mode=u=rwx,go=rx mandos $(PREFIX)/sbin/mandos
	install --mode=u=rw,go=r --target-directory=$(CONFDIR) \
		mandos.conf
	install --mode=u=rw --target-directory=$(CONFDIR) \
		clients.conf
	install --mode=u=rwx,go=rx init.d-mandos \
		$(DESTDIR)/etc/init.d/mandos
	install --mode=u=rw,go=r default-mandos \
		$(DESTDIR)/etc/default/mandos
	if [ -z $(DESTDIR) ]; then \
		update-rc.d mandos defaults 25 15;\
	fi
	gzip --best --to-stdout mandos.8 \
		> $(MANDIR)/man8/mandos.8.gz
	gzip --best --to-stdout mandos.conf.5 \
		> $(MANDIR)/man5/mandos.conf.5.gz
	gzip --best --to-stdout mandos-clients.conf.5 \
		> $(MANDIR)/man5/mandos-clients.conf.5.gz

install-client-nokey: all doc
	install --directory $(PREFIX)/lib/mandos $(CONFDIR)
	install --directory --mode=u=rwx $(KEYDIR) \
		$(PREFIX)/lib/mandos/plugins.d
	if [ "$(CONFDIR)" != "$(PREFIX)/lib/mandos" ]; then \
		install --mode=u=rwx \
			--directory "$(CONFDIR)/plugins.d"; \
	fi
	install --mode=u=rwx,go=rx \
		--target-directory=$(PREFIX)/lib/mandos plugin-runner
	install --mode=u=rwx,go=rx --target-directory=$(PREFIX)/sbin \
		mandos-keygen
	install --mode=u=rwx,go=rx \
		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
		plugins.d/password-prompt
	install --mode=u=rwxs,go=rx \
		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
		plugins.d/mandos-client
	install --mode=u=rwxs,go=rx \
		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
		plugins.d/usplash
	install --mode=u=rwxs,go=rx \
		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
		plugins.d/splashy
	install --mode=u=rwxs,go=rx \
		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
		plugins.d/askpass-fifo
	install initramfs-tools-hook \
		$(INITRAMFSTOOLS)/hooks/mandos
	install --mode=u=rw,go=r initramfs-tools-hook-conf \
		$(INITRAMFSTOOLS)/conf-hooks.d/mandos
	install initramfs-tools-script \
		$(INITRAMFSTOOLS)/scripts/init-premount/mandos
	install --mode=u=rw,go=r plugin-runner.conf $(CONFDIR)
	gzip --best --to-stdout mandos-keygen.8 \
		> $(MANDIR)/man8/mandos-keygen.8.gz
	gzip --best --to-stdout plugin-runner.8mandos \
		> $(MANDIR)/man8/plugin-runner.8mandos.gz
	gzip --best --to-stdout plugins.d/password-prompt.8mandos \
		> $(MANDIR)/man8/password-prompt.8mandos.gz
	gzip --best --to-stdout plugins.d/mandos-client.8mandos \
		> $(MANDIR)/man8/mandos-client.8mandos.gz
	gzip --best --to-stdout plugins.d/usplash.8mandos \
		> $(MANDIR)/man8/usplash.8mandos.gz
	gzip --best --to-stdout plugins.d/splashy.8mandos \
		> $(MANDIR)/man8/splashy.8mandos.gz
	gzip --best --to-stdout plugins.d/askpass-fifo.8mandos \
		> $(MANDIR)/man8/askpass-fifo.8mandos.gz

install-client: install-client-nokey
# Post-installation stuff
	-$(PREFIX)/sbin/mandos-keygen --dir "$(KEYDIR)"
	update-initramfs -k all -u
	echo "Now run mandos-keygen --password --dir $(KEYDIR)"

uninstall: uninstall-server uninstall-client

uninstall-server:
	-rm --force $(PREFIX)/sbin/mandos \
		$(MANDIR)/man8/mandos.8.gz \
		$(MANDIR)/man5/mandos.conf.5.gz \
		$(MANDIR)/man5/mandos-clients.conf.5.gz
	update-rc.d -f mandos remove
	-rmdir $(CONFDIR)

uninstall-client:
# Refuse to uninstall client if /etc/crypttab is explicitly configured
# to use it.
	! grep --regexp='^ *[^ #].*keyscript=[^,=]*/mandos/' \
		$(DESTDIR)/etc/crypttab
	-rm --force $(PREFIX)/sbin/mandos-keygen \
		$(PREFIX)/lib/mandos/plugin-runner \
		$(PREFIX)/lib/mandos/plugins.d/password-prompt \
		$(PREFIX)/lib/mandos/plugins.d/mandos-client \
		$(PREFIX)/lib/mandos/plugins.d/usplash \
		$(PREFIX)/lib/mandos/plugins.d/splashy \
		$(PREFIX)/lib/mandos/plugins.d/askpass-fifo \
		$(INITRAMFSTOOLS)/hooks/mandos \
		$(INITRAMFSTOOLS)/conf-hooks.d/mandos \
		$(INITRAMFSTOOLS)/scripts/init-premount/mandos \
		$(MANDIR)/man8/plugin-runner.8mandos.gz \
		$(MANDIR)/man8/mandos-keygen.8.gz \
		$(MANDIR)/man8/password-prompt.8mandos.gz \
		$(MANDIR)/man8/usplash.8mandos.gz \
		$(MANDIR)/man8/splashy.8mandos.gz \
		$(MANDIR)/man8/askpass-fifo.8mandos.gz \
		$(MANDIR)/man8/mandos-client.8mandos.gz
	-rmdir $(PREFIX)/lib/mandos/plugins.d $(CONFDIR)/plugins.d \
		 $(PREFIX)/lib/mandos $(CONFDIR) $(KEYDIR)
	update-initramfs -k all -u

purge: purge-server purge-client

purge-server: uninstall-server
	-rm --force $(CONFDIR)/mandos.conf $(CONFDIR)/clients.conf \
		$(DESTDIR)/etc/default/mandos \
		$(DESTDIR)/etc/init.d/mandos \
		$(DESTDIR)/var/run/mandos.pid
	-rmdir $(CONFDIR)

purge-client: uninstall-client
	-shred --remove $(KEYDIR)/seckey.txt
	-rm --force $(CONFDIR)/plugin-runner.conf \
		$(KEYDIR)/pubkey.txt $(KEYDIR)/seckey.txt

## mandos 1.0.13

=== Makefile ===
--- 
+++ 
@@ -16,7 +16,7 @@
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.0.8
+version=1.0.13
 SED=sed
 
 ## Use these settings for a traditional /usr/local install
@@ -35,8 +35,8 @@
 INITRAMFSTOOLS=$(DESTDIR)/usr/share/initramfs-tools
 ##
 
-GNUTLS_CFLAGS=$(shell libgnutls-config --cflags)
-GNUTLS_LIBS=$(shell libgnutls-config --libs)
+GNUTLS_CFLAGS=$(shell pkg-config --cflags-only-I gnutls)
+GNUTLS_LIBS=$(shell pkg-config --libs gnutls)
 AVAHI_CFLAGS=$(shell pkg-config --cflags-only-I avahi-core)
 AVAHI_LIBS=$(shell pkg-config --libs avahi-core)
 GPGME_CFLAGS=$(shell gpgme-config --cflags; getconf LFS_CFLAGS)

## mandos 1.0.14

=== Makefile ===
--- 
+++ 
@@ -9,14 +9,19 @@
 #DEBUG=-ggdb3
 # For info about _FORTIFY_SOURCE, see
 # <http://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>
-FORTIFY=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIC -fPIE
-LINK_FORTIFY_LD=-z relro -fPIE
-LINK_FORTIFY=-pie
+FORTIFY=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIC
+LINK_FORTIFY_LD=-z relro -z now
+LINK_FORTIFY=
+ifndef BROKEN_PIE
+FORTIFY += -fPIE
+LINK_FORTIFY_LD += -fPIE
+LINK_FORTIFY += -pie
+endif
 #COVERAGE=--coverage
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.0.13
+version=1.0.14
 SED=sed
 
 ## Use these settings for a traditional /usr/local install
@@ -356,5 +361,3 @@
 
 purge-client: uninstall-client
 	-shred --remove $(KEYDIR)/seckey.txt
-	-rm --force $(CONFDIR)/plugin-runner.conf \
-		$(KEYDIR)/pubkey.txt $(KEYDIR)/seckey.txt

## mandos 1.3.0

=== Makefile ===
--- 
+++ 
@@ -8,20 +8,22 @@
 #	-Wunreachable-code 
 #DEBUG=-ggdb3
 # For info about _FORTIFY_SOURCE, see
-# <http://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>
+# <http://www.kernel.org/doc/man-pages/online/pages/man7/feature_test_macros.7.html>
+# and <http://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>.
 FORTIFY=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIC
 LINK_FORTIFY_LD=-z relro -z now
 LINK_FORTIFY=
+
+# If BROKEN_PIE is set, do not build with -pie
 ifndef BROKEN_PIE
 FORTIFY += -fPIE
-LINK_FORTIFY_LD += -fPIE
 LINK_FORTIFY += -pie
 endif
 #COVERAGE=--coverage
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.0.14
+version=1.3.0
 SED=sed
 
 ## Use these settings for a traditional /usr/local install
@@ -55,7 +57,7 @@
 LDFLAGS=$(COVERAGE) $(LINK_FORTIFY) $(foreach flag,$(LINK_FORTIFY_LD),-Xlinker $(flag))
 
 # Commands to format a DocBook <refentry> document into a manual page
-DOCBOOKTOMAN=cd $(dir $<); xsltproc --nonet --xinclude \
+DOCBOOKTOMAN=$(strip cd $(dir $<); xsltproc --nonet --xinclude \
 	--param man.charmap.use.subset		0 \
 	--param make.year.ranges		1 \
 	--param make.single.year.ranges		1 \
@@ -63,11 +65,11 @@
 	--param man.authors.section.enabled	0 \
 	 /usr/share/xml/docbook/stylesheet/nwalsh/manpages/docbook.xsl \
 	$(notdir $<); \
-	$(MANPOST) $(notdir $@)
+	$(MANPOST) $(notdir $@))
 # DocBook-to-man post-processing to fix a '\n' escape bug
 MANPOST=$(SED) --in-place --expression='s,\\\\en,\\en,g;s,\\n,\\en,g'
 
-DOCBOOKTOHTML=xsltproc --nonet --xinclude \
+DOCBOOKTOHTML=$(strip xsltproc --nonet --xinclude \
 	--param make.year.ranges		1 \
 	--param make.single.year.ranges		1 \
 	--param man.output.quietly		1 \
@@ -75,20 +77,22 @@
 	--param citerefentry.link		1 \
 	--output $@ \
 	/usr/share/xml/docbook/stylesheet/nwalsh/xhtml/docbook.xsl \
-	$<; $(HTMLPOST) $@
+	$<; $(HTMLPOST) $@)
 # Fix citerefentry links
 HTMLPOST=$(SED) --in-place \
 	--expression='s/\(<a class="citerefentry" href="\)\("><span class="citerefentry"><span class="refentrytitle">\)\([^<]*\)\(<\/span>(\)\([^)]*\)\()<\/span><\/a>\)/\1\3.\5\2\3\4\5\6/g'
 
 PLUGINS=plugins.d/password-prompt plugins.d/mandos-client \
-	plugins.d/usplash plugins.d/splashy plugins.d/askpass-fifo
+	plugins.d/usplash plugins.d/splashy plugins.d/askpass-fifo \
+	plugins.d/plymouth
 CPROGS=plugin-runner $(PLUGINS)
-PROGS=mandos mandos-keygen mandos-ctl $(CPROGS)
-DOCS=mandos.8 plugin-runner.8mandos mandos-keygen.8 \
+PROGS=mandos mandos-keygen mandos-ctl mandos-monitor $(CPROGS)
+DOCS=mandos.8 mandos-keygen.8 mandos-monitor.8 mandos-ctl.8 \
+	mandos.conf.5 mandos-clients.conf.5 plugin-runner.8mandos \
 	plugins.d/mandos-client.8mandos \
-	plugins.d/password-prompt.8mandos mandos.conf.5 \
-	plugins.d/usplash.8mandos plugins.d/splashy.8mandos \
-	plugins.d/askpass-fifo.8mandos mandos-clients.conf.5
+	plugins.d/password-prompt.8mandos plugins.d/usplash.8mandos \
+	plugins.d/splashy.8mandos plugins.d/askpass-fifo.8mandos \
+	plugins.d/plymouth.8mandos
 
 htmldocs=$(addsuffix .xhtml,$(DOCS))
 
@@ -126,6 +130,20 @@
 		legalnotice.xml
 	$(DOCBOOKTOMAN)
 mandos-keygen.8.xhtml: mandos-keygen.xml common.ent overview.xml \
+		 legalnotice.xml
+	$(DOCBOOKTOHTML)
+
+mandos-monitor.8: mandos-monitor.xml common.ent overview.xml \
+		legalnotice.xml
+	$(DOCBOOKTOMAN)
+mandos-monitor.8.xhtml: mandos-monitor.xml common.ent overview.xml \
+		 legalnotice.xml
+	$(DOCBOOKTOHTML)
+
+mandos-ctl.8: mandos-ctl.xml common.ent overview.xml \
+		legalnotice.xml
+	$(DOCBOOKTOMAN)
+mandos-ctl.8.xhtml: mandos-ctl.xml common.ent overview.xml \
 		 legalnotice.xml
 	$(DOCBOOKTOHTML)
 
@@ -156,39 +174,44 @@
 
 # Update all these files with version number $(version)
 common.ent: Makefile
-	$(SED) --in-place \
+	$(strip $(SED) --in-place \
 		--expression='s/^\(<!ENTITY version "\)[^"]*">$$/\1$(version)">/' \
-		$@
+		$@)
 
 mandos: Makefile
-	$(SED) --in-place \
+	$(strip $(SED) --in-place \
 		--expression='s/^\(version = "\)[^"]*"$$/\1$(version)"/' \
-		$@
+		$@)
 
 mandos-keygen: Makefile
-	$(SED) --in-place \
+	$(strip $(SED) --in-place \
 		--expression='s/^\(VERSION="\)[^"]*"$$/\1$(version)"/' \
-		$@
+		$@)
 
 mandos-ctl: Makefile
-	$(SED) --in-place \
+	$(strip $(SED) --in-place \
 		--expression='s/^\(version = "\)[^"]*"$$/\1$(version)"/' \
-		$@
+		$@)
+
+mandos-monitor: Makefile
+	$(strip $(SED) --in-place \
+		--expression='s/^\(version = "\)[^"]*"$$/\1$(version)"/' \
+		$@)
 
 mandos.lsm: Makefile
-	$(SED) --in-place \
+	$(strip $(SED) --in-place \
 		--expression='s/^\(Version:\).*/\1\t$(version)/' \
-		$@
-	$(SED) --in-place \
+		$@)
+	$(strip $(SED) --in-place \
 		--expression='s/^\(Entered-date:\).*/\1\t$(shell date --rfc-3339=date --reference=Makefile)/' \
-		$@
-	$(SED) --in-place \
+		$@)
+	$(strip $(SED) --in-place \
 		--expression='s/\(mandos_\)[0-9.]\+\(\.orig\.tar\.gz\)/\1$(version)\2/' \
-		$@
-
-plugins.d/mandos-client: plugins.d/mandos-client.o
-	$(LINK.o) $(GNUTLS_LIBS) $(AVAHI_LIBS) $(GPGME_LIBS) \
-		$(COMMON) $^ $(LOADLIBES) $(LDLIBS) -o $@
+		$@)
+
+plugins.d/mandos-client: plugins.d/mandos-client.c
+	$(LINK.c) $(GNUTLS_LIBS) $(AVAHI_LIBS) $(GPGME_LIBS) $(strip\
+		) $(COMMON) $^ $(LOADLIBES) $(LDLIBS) -o $@
 
 .PHONY : all doc html clean distclean run-client run-server install \
 	install-server install-client uninstall uninstall-server \
@@ -207,6 +230,17 @@
 
 # Run the client with a local config and key
 run-client: all keydir/seckey.txt keydir/pubkey.txt
+	@echo "###################################################################"
+	@echo "# The following error messages are harmless and can be safely     #"
+	@echo "# ignored.  The messages are caused by not running as root, but   #"
+	@echo "# you should NOT run \"make run-client\" as root unless you also    #"
+	@echo "# unpacked and compiled Mandos as root, which is NOT recommended. #"
+	@echo "# From plugin-runner: setuid: Operation not permitted             #"
+	@echo "# From askpass-fifo:  mkfifo: Permission denied                   #"
+	@echo "# From mandos-client: setuid: Operation not permitted             #"
+	@echo "#                     seteuid: Operation not permitted            #"
+	@echo "#                     klogctl: Operation not permitted            #"
+	@echo "###################################################################"
 	./plugin-runner --plugin-dir=plugins.d \
 		--config-file=plugin-runner.conf \
 		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt \
@@ -219,6 +253,12 @@
 
 # Run the server with a local config
 run-server: confdir/mandos.conf confdir/clients.conf
+	@echo "#################################################################"
+	@echo "# NOTE: Please IGNORE the error about \"Could not open file      #"
+	@echo "# u'/var/run/mandos.pid'\" -  it is harmless and is caused by    #"
+	@echo "# the server not running as root.  Do NOT run \"make run-server\" #"
+	@echo "# server as root if you didn't also unpack and compile it thus. #"
+	@echo "#################################################################"
 	./mandos --debug --no-dbus --configdir=confdir $(SERVERARGS)
 
 # Used by run-server
@@ -241,10 +281,16 @@
 install-server: doc
 	install --directory $(CONFDIR)
 	install --mode=u=rwx,go=rx mandos $(PREFIX)/sbin/mandos
+	install --mode=u=rwx,go=rx --target-directory=$(PREFIX)/sbin \
+		mandos-ctl
+	install --mode=u=rwx,go=rx --target-directory=$(PREFIX)/sbin \
+		mandos-monitor
 	install --mode=u=rw,go=r --target-directory=$(CONFDIR) \
 		mandos.conf
 	install --mode=u=rw --target-directory=$(CONFDIR) \
 		clients.conf
+	install --mode=u=rw,go=r dbus-mandos.conf \
+		$(DESTDIR)/etc/dbus-1/system.d/mandos.conf
 	install --mode=u=rwx,go=rx init.d-mandos \
 		$(DESTDIR)/etc/init.d/mandos
 	install --mode=u=rw,go=r default-mandos \
@@ -254,6 +300,10 @@
 	fi
 	gzip --best --to-stdout mandos.8 \
 		> $(MANDIR)/man8/mandos.8.gz
+	gzip --best --to-stdout mandos-monitor.8 \
+		> $(MANDIR)/man8/mandos-monitor.8.gz
+	gzip --best --to-stdout mandos-ctl.8 \
+		> $(MANDIR)/man8/mandos-ctl.8.gz
 	gzip --best --to-stdout mandos.conf.5 \
 		> $(MANDIR)/man5/mandos.conf.5.gz
 	gzip --best --to-stdout mandos-clients.conf.5 \
@@ -286,78 +336,10 @@
 	install --mode=u=rwxs,go=rx \
 		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
 		plugins.d/askpass-fifo
+	install --mode=u=rwxs,go=rx \
+		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
+		plugins.d/plymouth
 	install initramfs-tools-hook \
 		$(INITRAMFSTOOLS)/hooks/mandos
 	install --mode=u=rw,go=r initramfs-tools-hook-conf \
 		$(INITRAMFSTOOLS)/conf-hooks.d/mandos
-	install initramfs-tools-script \
-		$(INITRAMFSTOOLS)/scripts/init-premount/mandos
-	install --mode=u=rw,go=r plugin-runner.conf $(CONFDIR)
-	gzip --best --to-stdout mandos-keygen.8 \
-		> $(MANDIR)/man8/mandos-keygen.8.gz
-	gzip --best --to-stdout plugin-runner.8mandos \
-		> $(MANDIR)/man8/plugin-runner.8mandos.gz
-	gzip --best --to-stdout plugins.d/password-prompt.8mandos \
-		> $(MANDIR)/man8/password-prompt.8mandos.gz
-	gzip --best --to-stdout plugins.d/mandos-client.8mandos \
-		> $(MANDIR)/man8/mandos-client.8mandos.gz
-	gzip --best --to-stdout plugins.d/usplash.8mandos \
-		> $(MANDIR)/man8/usplash.8mandos.gz
-	gzip --best --to-stdout plugins.d/splashy.8mandos \
-		> $(MANDIR)/man8/splashy.8mandos.gz
-	gzip --best --to-stdout plugins.d/askpass-fifo.8mandos \
-		> $(MANDIR)/man8/askpass-fifo.8mandos.gz
-
-install-client: install-client-nokey
-# Post-installation stuff
-	-$(PREFIX)/sbin/mandos-keygen --dir "$(KEYDIR)"
-	update-initramfs -k all -u
-	echo "Now run mandos-keygen --password --dir $(KEYDIR)"
-
-uninstall: uninstall-server uninstall-client
-
-uninstall-server:
-	-rm --force $(PREFIX)/sbin/mandos \
-		$(MANDIR)/man8/mandos.8.gz \
-		$(MANDIR)/man5/mandos.conf.5.gz \
-		$(MANDIR)/man5/mandos-clients.conf.5.gz
-	update-rc.d -f mandos remove
-	-rmdir $(CONFDIR)
-
-uninstall-client:
-# Refuse to uninstall client if /etc/crypttab is explicitly configured
-# to use it.
-	! grep --regexp='^ *[^ #].*keyscript=[^,=]*/mandos/' \
-		$(DESTDIR)/etc/crypttab
-	-rm --force $(PREFIX)/sbin/mandos-keygen \
-		$(PREFIX)/lib/mandos/plugin-runner \
-		$(PREFIX)/lib/mandos/plugins.d/password-prompt \
-		$(PREFIX)/lib/mandos/plugins.d/mandos-client \
-		$(PREFIX)/lib/mandos/plugins.d/usplash \
-		$(PREFIX)/lib/mandos/plugins.d/splashy \
-		$(PREFIX)/lib/mandos/plugins.d/askpass-fifo \
-		$(INITRAMFSTOOLS)/hooks/mandos \
-		$(INITRAMFSTOOLS)/conf-hooks.d/mandos \
-		$(INITRAMFSTOOLS)/scripts/init-premount/mandos \
-		$(MANDIR)/man8/plugin-runner.8mandos.gz \
-		$(MANDIR)/man8/mandos-keygen.8.gz \
-		$(MANDIR)/man8/password-prompt.8mandos.gz \
-		$(MANDIR)/man8/usplash.8mandos.gz \
-		$(MANDIR)/man8/splashy.8mandos.gz \
-		$(MANDIR)/man8/askpass-fifo.8mandos.gz \
-		$(MANDIR)/man8/mandos-client.8mandos.gz
-	-rmdir $(PREFIX)/lib/mandos/plugins.d $(CONFDIR)/plugins.d \
-		 $(PREFIX)/lib/mandos $(CONFDIR) $(KEYDIR)
-	update-initramfs -k all -u
-
-purge: purge-server purge-client
-
-purge-server: uninstall-server
-	-rm --force $(CONFDIR)/mandos.conf $(CONFDIR)/clients.conf \
-		$(DESTDIR)/etc/default/mandos \
-		$(DESTDIR)/etc/init.d/mandos \
-		$(DESTDIR)/var/run/mandos.pid
-	-rmdir $(CONFDIR)
-
-purge-client: uninstall-client
-	-shred --remove $(KEYDIR)/seckey.txt

=== debian/changelog ===
mandos (1.3.0-1ubuntu1) oneiric; urgency=low

  * debian/patches/fix-ftbfs-with-as-needed:
    - Fix FTBFS with --as-needed (LP: #771019) (Closes: #632145)

 -- Angel Abad <angelabad@ubuntu.com>  Wed, 29 Jun 2011 22:44:52 +0200

mandos (1.3.0-1) unstable; urgency=low

  * New upstream release.
  * debian/control (mandos): Depend on Python 2.6, remove dependency on
    python-multiprocessing.
  (mandos-client): Conflict with dropbear (<< 0.52-5).
  * debian/mandos-client.postrm (purge): Bug fix: update initramfs also on
    purge.
  * debian/mandos-client.lintian-overrides: Added plugins.d/plymouth.

 -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Tue, 08 Mar 2011 20:22:57 +0100

mandos (1.2.3-1) experimental; urgency=low

  * New upstream release.

 -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Mon, 11 Oct 2010 19:37:31 +0200

mandos (1.2.2-1) experimental; urgency=low

  * New upstream release.
  * plugins.d/splashy.c: Only use ELIBBAD if defined. (Closes: #599256)

 -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Thu, 07 Oct 2010 20:27:54 +0200

mandos (1.2.1-3) experimental; urgency=low

  * debian/changelog: Include entry for NMU of version 1.0.14-1.1.

 -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Tue, 05 Oct 2010 20:58:38 +0200

mandos (1.2.1-2) unstable; urgency=low

  * debian/source/format: New; contains "3.0 (quilt)".  Really.

 -- Björn Påhlsson <belorn@fukt.bsnet.se>  Sat, 02 Oct 2010 19:46:59 +0200

mandos (1.2.1-1) unstable; urgency=low

  * New upstream release.
  * debian/source/format: New; contains "3.0 (quilt)".

 -- Björn Påhlsson <belorn@fukt.bsnet.se>  Sat, 02 Oct 2010 19:03:58 +0200

mandos (1.2-1) unstable; urgency=low

  * New upstream release.
  * Makefile (LINK_FORTIFY_LD): Remove "-fPIE". (Closes: #557076)
  * debian/control: Add gnupg dependency to "mandos-client" and removed it
    from "mandos".  Added dependency on "python-urwid" "mandos" since the
    new "mandos-monitor" utility needs it, and on "python (>=2.6) |
    python-multiprocessing" since the Mandos server now uses it.
  * debian/rules: Set BROKEN_PIE on mips and mipsel if a known buggy
    version of binutils is used.
  * debian/mandos.docs: Also install "/usr/share/doc/mandos/DBUS-API".
  * debian/mandos.dirs: Added "etc/dbus-1/system.d".
  * debian/mandos-client.README.Debian: Update info about DEVICE setting
    of initramfs.conf.
  * debian/mandos-client.README.Debian: Remove warning about --connect not
    looping, since it now does.

 -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Tue, 28 Sep 2010 20:46:11 +0200

mandos (1.0.14-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Rebuild against libavahi-core-dev (>= 0.6.26-1).

 -- Michael Biebl <biebl@debian.org>  Mon, 12 Jul 2010 16:34:34 +0200

mandos (1.0.14-1) unstable; urgency=low (HIGH on mips and mipsel)

  * New upstream release.
  * debian/rules: Build with BROKEN_PIE set on mips and mipsel
    architectures - fixes FTBFS there.

 -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Sun, 25 Oct 2009 20:10:09 +0100

mandos (1.0.13-1) unstable; urgency=high

  * New upstream release.
  * Do not copy unnecessary files to initrd (Closes: #551907)

 -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Thu, 22 Oct 2009 00:53:21 +0200

mandos (1.0.12-1) unstable; urgency=low

  * New upstream release.
  * init.d-mandos: Correct dependencies (Closes: #546928)
  * debian/control (Standards-Version): Changed to "3.8.3".
  * debian/mandos-client.README.Debian: Improved wording and formatting.
    Updated location of nfsroot.txt.
  * debian/mandos.README.Debian: Improved wording and formatting.
  * debian/mandos-client.postinst (configure): Don't look for user and
    group with the old name if upgrading from a new enough version.
  * debian/mandos.postinst (configure): - '' -
  * debian/mandos-client.README.Debian: Added text about non-usability of
    pseudo-network interfaces.

 -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Thu, 17 Sep 2009 15:03:59 +0200

mandos (1.0.11-1) unstable; urgency=low

  * debian/control (Standards-Version): Changed to "3.8.1".
  * Makefile (GNUTLS_CFLAGS, GNUTLS_CFLAGS): Use "pkg-config" instead of
    the old "libgnutls-config" script.  (Closes:  #529836)

 -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Sat, 23 May 2009 07:12:20 +0200

mandos (1.0.10-1) unstable; urgency=low

  * New upstream release.
  * debian/mandos-client.postinst (update_initramfs): Fix permissions of
    old initrd.img-*.bak files.

 -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Sun, 17 May 2009 04:56:35 +0200

mandos (1.0.9-1) unstable; urgency=low

  * New upstream release.

 -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Sun, 17 May 2009 02:59:45 +0200

mandos (1.0.8-1) unstable; urgency=low

  * New upstream release.

 -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Wed, 25 Feb 2009 02:26:57 +0100

mandos (1.0.7-1) unstable; urgency=low

  * New upstream release.

 -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Tue, 24 Feb 2009 12:58:06 +0100

mandos (1.0.6-1) unstable; urgency=low

  * New upstream release.
  * debian/mandos-client.postinst: Converted to Bourne shell.  Also
    minor message change.
  * debian/mandos-client.postrm: Minor message change.
  * debian/mandos.postinst: Converted to Bourne shell.  Also minor
    message change.
  * debian/mandos.prerm: Minor message change.
  * debian/rules (install-indep): Removed "--no-start" from
    dh_installinit.
  * debian/mandos-client.lintian-overrides: Remove obsolete override for
    unbreakable line in plugin-runner manual page.
  * debian/control (mandos/Depends): Added "python-gobject".
  * debian/mandos-client.dirs: Change
    "usr/share/initramfs-tools/scripts/local-top" to
    "usr/share/initramfs-tools/scripts/init-premount".
  * debian/mandos-client.README.Debian: Add reference to initramfs.conf
    and nfsroot.txt.  New section about the new non-local connection
    feature.

 -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Fri, 13 Feb 2009 09:27:25 +0100

mandos (1.0.5-1) unstable; urgency=low

  * New upstream release.



=== debian/control ===
Source: mandos
Section: admin
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Mandos Maintainers <mandos@fukt.bsnet.se>
Uploaders: Teddy Hogeborn <teddy@fukt.bsnet.se>,
	   Björn Påhlsson <belorn@fukt.bsnet.se>
Build-Depends: debhelper (>= 7), docbook-xml, docbook-xsl,
	libavahi-core-dev, libgpgme11-dev, libgnutls-dev, xsltproc,
	pkg-config
Standards-Version: 3.9.1
Vcs-Bzr: http://ftp.fukt.bsnet.se/pub/mandos/trunk
Vcs-Browser: http://bzr.fukt.bsnet.se/loggerhead/mandos/trunk/files
Homepage: http://www.fukt.bsnet.se/mandos

Package: mandos
Architecture: all
Depends: ${misc:Depends}, python (>=2.6), python-gnutls, python-dbus,
	python-avahi, python-gobject, avahi-daemon, adduser,
	python-urwid
Recommends: fping
Description: a server giving encrypted passwords to Mandos clients
 This is the server part of the Mandos system, which allows
 computers to have encrypted root file systems and at the
 same time be capable of remote and/or unattended reboots.
 .
 The computers run a small client program in the initial RAM
 disk environment which will communicate with a server over a
 network.  All network communication is encrypted using TLS.
 The clients are identified by the server using an OpenPGP
 key; each client has one unique to it.  The server sends the
 clients an encrypted password.  The encrypted password is
 decrypted by the clients using the same OpenPGP key, and the
 password is then used to unlock the root file system,
 whereupon the computers can continue booting normally.

Package: mandos-client
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup,
	gnupg (<< 2)
Conflicts: dropbear (<< 0.52-5)
Enhances: cryptsetup
Description: do unattended reboots with an encrypted root file system
 This is the client part of the Mandos system, which allows
 computers to have encrypted root file systems and at the
 same time be capable of remote and/or unattended reboots.
 .
 The computers run a small client program in the initial RAM
 disk environment which will communicate with a server over a
 network.  All network communication is encrypted using TLS.
 The clients are identified by the server using an OpenPGP
 key; each client has one unique to it.  The server sends the
 clients an encrypted password.  The encrypted password is
 decrypted by the clients using the same OpenPGP key, and the
 password is then used to unlock the root file system,
 whereupon the computers can continue booting normally.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

# -pie was broken briefly on the mips and mipsel architectures, see
# <http://bugs.debian.org/526961>
BINUTILS_V := $(shell dpkg-query --showformat='$${Version}' \
			--show binutils)
ifeq (yes,$(shell dpkg --compare-versions $(BINUTILS_V) lt 2.20-3 \
		&& dpkg --compare-versions $(BINUTILS_V) ge 2.19.1-1 \
		&& echo yes))
  ifneq (,$(strip $(findstring :$(DEB_HOST_ARCH):,:mips:mipsel:) \
		$(findstring :$(DEB_BUILD_ARCH):,:mips:mipsel:)))
    BROKEN_PIE := yes
    export BROKEN_PIE
  endif
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	touch configure-stamp

build: build-arch build-indep

build-arch: build-arch-stamp
build-arch-stamp: configure-stamp
	dh_auto_build -- all doc
	touch $@

build-indep: build-indep-stamp
build-indep-stamp: configure-stamp
	dh_auto_build -- doc
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-arch-stamp build-indep-stamp configure-stamp
	dh_auto_clean
	dh_clean

install: install-indep install-arch
install-indep:
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs --indep
	$(MAKE) DESTDIR=$(CURDIR)/debian/mandos install-server
	dh_lintian
	dh_installinit --onlyscripts \
		--update-rcd-params="defaults 25 15"
	dh_install --indep

install-arch:
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs --same-arch
	$(MAKE) DESTDIR=$(CURDIR)/debian/mandos-client install-client-nokey
	dh_lintian
	dh_install --same-arch

binary-common:
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs
	dh_link
	dh_strip
	dh_compress
	dh_fixperms --exclude etc/keys/mandos \
		--exclude etc/mandos/clients.conf \
		--exclude etc/mandos/plugins.d \
		--exclude usr/lib/mandos/plugins.d
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# Build architecture independant packages using the common target.
binary-indep: build-indep install-indep
	$(MAKE) -f debian/rules DH_OPTIONS=--indep binary-common

# Build architecture dependant packages using the common target.
binary-arch: build-arch install-arch
	$(MAKE) -f debian/rules DH_OPTIONS=--same-arch binary-common

binary: binary-arch binary-indep

.PHONY: build clean binary-indep binary-arch binary install \
		install-indep install-arch configure

=== debian/watch ===
version=3
ftp://ftp.fukt.bsnet.se/pub/mandos/mandos[-_]([^\s]+?)(?:\.orig)?\.tar\.(?:gz|bz2|7z|xz)

## mandos 1.4.0

=== Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 	-Wbad-function-cast -Wcast-qual -Wcast-align -Wwrite-strings \
 	-Wconversion -Wstrict-prototypes -Wold-style-definition \
 	-Wpacked -Wnested-externs -Winline -Wvolatile-register-var
-#	-Wunreachable-code 
+#	-Wunreachable-code
 #DEBUG=-ggdb3
 # For info about _FORTIFY_SOURCE, see
 # <http://www.kernel.org/doc/man-pages/online/pages/man7/feature_test_macros.7.html>
@@ -23,7 +23,7 @@
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.3.0
+version=1.4.0
 SED=sed
 
 ## Use these settings for a traditional /usr/local install
@@ -54,7 +54,7 @@
 CFLAGS=$(WARN) $(DEBUG) $(FORTIFY) $(COVERAGE) $(OPTIMIZE) \
 	$(LANGUAGE) $(GNUTLS_CFLAGS) $(AVAHI_CFLAGS) $(GPGME_CFLAGS) \
 	-DVERSION='"$(version)"'
-LDFLAGS=$(COVERAGE) $(LINK_FORTIFY) $(foreach flag,$(LINK_FORTIFY_LD),-Xlinker $(flag))
+LDFLAGS=-Xlinker --as-needed $(COVERAGE) $(LINK_FORTIFY) $(foreach flag,$(LINK_FORTIFY_LD),-Xlinker $(flag))
 
 # Commands to format a DocBook <refentry> document into a manual page
 DOCBOOKTOMAN=$(strip cd $(dir $<); xsltproc --nonet --xinclude \
@@ -92,7 +92,7 @@
 	plugins.d/mandos-client.8mandos \
 	plugins.d/password-prompt.8mandos plugins.d/usplash.8mandos \
 	plugins.d/splashy.8mandos plugins.d/askpass-fifo.8mandos \
-	plugins.d/plymouth.8mandos
+	plugins.d/plymouth.8mandos intro.8mandos
 
 htmldocs=$(addsuffix .xhtml,$(DOCS))
 
@@ -117,6 +117,11 @@
 %.8mandos: %.xml common.ent legalnotice.xml
 	$(DOCBOOKTOMAN)
 %.8mandos.xhtml: %.xml common.ent legalnotice.xml
+	$(DOCBOOKTOHTML)
+
+intro.8mandos: intro.xml common.ent legalnotice.xml
+	$(DOCBOOKTOMAN)
+intro.8mandos.xhtml: intro.xml common.ent legalnotice.xml
 	$(DOCBOOKTOHTML)
 
 mandos.8: mandos.xml common.ent mandos-options.xml overview.xml \
@@ -210,8 +215,8 @@
 		$@)
 
 plugins.d/mandos-client: plugins.d/mandos-client.c
-	$(LINK.c) $(GNUTLS_LIBS) $(AVAHI_LIBS) $(GPGME_LIBS) $(strip\
-		) $(COMMON) $^ $(LOADLIBES) $(LDLIBS) -o $@
+	$(LINK.c) $^ -lrt $(GNUTLS_LIBS) $(AVAHI_LIBS) $(strip\
+		) $(GPGME_LIBS) $(LOADLIBES) $(LDLIBS) -o $@
 
 .PHONY : all doc html clean distclean run-client run-server install \
 	install-server install-client uninstall uninstall-server \
@@ -339,7 +344,3 @@
 	install --mode=u=rwxs,go=rx \
 		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
 		plugins.d/plymouth
-	install initramfs-tools-hook \
-		$(INITRAMFSTOOLS)/hooks/mandos
-	install --mode=u=rw,go=r initramfs-tools-hook-conf \
-		$(INITRAMFSTOOLS)/conf-hooks.d/mandos

=== debian/changelog ===
mandos (1.4.0-1) unstable; urgency=low

  * New upstream release.
  * Fix "FTBFS with binutils-gold": Added "-Xlinker --as-needed" to
    LDFLAGS in Makefile. (Closes: #632145)
  * Fix "/run transition: uses obsolete /dev/.initramfs": Try both old and
    new PID file locations. (Closes: #643554)
  * debian/source/local-options: New; contains "--single-debian-patch".
  * debian/control (Standards-Version): Upgraded to "3.9.2".
    (DM-Upload-Allowed): New; set to "yes".
  * debian/control: Changed domain from "fukt.bsnet.se" to "recompile.se".
  * debian/copyright: - '' -
  * debian/mandos-client.README.Debian: - '' -
  * debian/mandos.README.Debian: - '' -
  * debian/watch: - '' -
  * debian/control (mandos/Description): Fix language to placate lintian.

 -- Teddy Hogeborn <teddy@recompile.se>  Sun, 09 Oct 2011 19:15:08 +0200

mandos (1.3.1-1) unstable; urgency=low

  * New upstream release.
  * Conflict with correct version of dropbear.
  * New version uses argparse; depend on python (<=2.7) | python-argparse.

 -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Wed, 27 Jul 2011 19:47:17 +0200

=== debian/control ===
--- 
+++ 
@@ -1,25 +1,25 @@
 Source: mandos
 Section: admin
 Priority: extra
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Mandos Maintainers <mandos@fukt.bsnet.se>
-Uploaders: Teddy Hogeborn <teddy@fukt.bsnet.se>,
-	   Björn Påhlsson <belorn@fukt.bsnet.se>
+Maintainer: Mandos Maintainers <mandos@recompile.se>
+Uploaders: Teddy Hogeborn <teddy@recompile.se>,
+	   Björn Påhlsson <belorn@recompile.se>
 Build-Depends: debhelper (>= 7), docbook-xml, docbook-xsl,
 	libavahi-core-dev, libgpgme11-dev, libgnutls-dev, xsltproc,
 	pkg-config
-Standards-Version: 3.9.1
-Vcs-Bzr: http://ftp.fukt.bsnet.se/pub/mandos/trunk
-Vcs-Browser: http://bzr.fukt.bsnet.se/loggerhead/mandos/trunk/files
-Homepage: http://www.fukt.bsnet.se/mandos
+Standards-Version: 3.9.2
+Vcs-Bzr: http://ftp.recompile.se/pub/mandos/trunk
+Vcs-Browser: http://bzr.recompile.se/loggerhead/mandos/trunk/files
+Homepage: http://www.recompile.se/mandos
+DM-Upload-Allowed: yes
 
 Package: mandos
 Architecture: all
 Depends: ${misc:Depends}, python (>=2.6), python-gnutls, python-dbus,
 	python-avahi, python-gobject, avahi-daemon, adduser,
-	python-urwid
+	python-urwid, python (>=2.7) | python-argparse
 Recommends: fping
-Description: a server giving encrypted passwords to Mandos clients
+Description: server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows
  computers to have encrypted root file systems and at the
  same time be capable of remote and/or unattended reboots.
@@ -38,7 +38,7 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup,
 	gnupg (<< 2)
-Conflicts: dropbear (<< 0.52-5)
+Conflicts: dropbear (<= 0.52-5)
 Enhances: cryptsetup
 Description: do unattended reboots with an encrypted root file system
  This is the client part of the Mandos system, which allows
